 #include "kBitArrayLong.h"
 
/*-----------------------------------------------------------------
 Initilization of the kBitArray
 ---------------------------------------------------------------- */ 
 t_kBitArray create_kBitArrayLong (size_t size, uint elemSize) {
	 
 	t_kBitArray	 V = (t_kBitArray) malloc (sizeof(struct akbitArr));
 	
 	V->totalInts = uint_len(elemSize,size);
 	V->data = (uint *) malloc((V->totalInts) * sizeof(uint));
	V->data[V->totalInts-1]=0000; /** avoids valgrind to blame*/
 	V->size = size;
 	V->elemSize= elemSize;
 	printf("\nKbitVector[0,%zu), of elemSize = %u initialized\n",V->size,V->elemSize);
 	printf("\ntotalInts = %zu, size = %zu  elemSize = %u\n",V->totalInts,V->size,V->elemSize);
 	return V;
}

size_t getKBitArrayLong(t_kBitArray V, register size_t i) {
	register uint eSize = V->elemSize;
	
	if (eSize <=W) {
		return ( bitread(V->data,i * eSize, eSize)); 
	}
	else {
		size_t val1 = ( bitread(V->data,i * eSize, eSize-W)); 
		size_t val2 = ( bitread(V->data,i * eSize + (eSize-W), W)); 
		return ((val1 << W) | val2);		
	}
}

void setKBitArrayLong(t_kBitArray V, size_t i, size_t value){
	register uint eSize = V->elemSize;
	if (eSize <=W) {
		bitwrite(V->data,i *eSize, eSize, value); 
	}
	else {	
		bitwrite(V->data,i *eSize, eSize-W, value>>W);
		bitwrite(V->data,i *eSize + (eSize-W), W , (value& 0xFFFFFFFF));
	}
}

/*-----------------------------------------------------------------
 freeing resources
 ---------------------------------------------------------------- */ 
void destroy_kBitArrayLong (t_kBitArray kBitArray) {
	//size_t total;
	//total = (kBitArray->totalInts) * sizeof(uint);
	
	free(kBitArray->data);
	free(kBitArray);	
	//printf("\n[destroying a Kbit array of size table]...Freed %zu bytes... RAM", total);		
}


size_t size_kBitArrayLong (t_kBitArray kBitArray) {
	return ((kBitArray->totalInts) * sizeof(uint) + sizeof(struct akbitArr ));
	//return ((kBitArray->totalInts) * sizeof(uint));
}

