/* test_dump.cpp
 * Copyright (C) 2010, Francisco Claude, all rights reserved.
 *
 * Program to test "extract" in the int-based SSA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include <ssa_words.h>
#include <iostream>
#include <fstream>
#include <sstream>

using namespace std;

ssa_words * _ssa;

bool check_extract(uint * text, uint n, uint * copy) {
  for(int i=n-1;i>=0;i--)
  if(text[i]!=copy[i]) {
    cout << "Error at position " << i << endl;
    cout << "text[i] = " << text[i] << endl;
    cout << "copy[i] = " << copy[i] << endl;
    uint * seq = _ssa->extract(i-1,i+2);
    cout << seq[0] << seq[1] << seq[2] << endl;
    delete [] seq;
    //return false;
  }
  return true;
}


int main(int argc, char ** argv) {
  if(argc!=3) {
    cout << "usage: " << argv[0] << " <int-file> <index-file>" << endl;
    return 0;
  }

  fstream input(argv[1],ios::in | ios::binary);
  if(!input.is_open()) {
    cout << "Error opening file: " << argv[1] << endl;
    return -1;
  }

  input.seekg(0,ios::end);
  uint n=input.tellg()/4;
  uint * text = new uint[n+1];

  input.seekg(0,ios::beg);
  input.read((char*)text,sizeof(uint)*n);
  input.close();
  //for(uint i=0;i<n;i++) text[i]++;
  text[n] = 0;

  bool err;
  FILE * fp = fopen(argv[2],"r");
  _ssa = new ssa_words(fp,err);
  fclose(fp);
  _ssa->print_stats();

  uint * copy = _ssa->rebuild();

  cout << "Done " << check_extract(text,n,copy) <<  endl;

  delete _ssa;
  delete [] text;
  delete [] copy;

  return 0;
}
