/* test_dump2.cpp
 * Copyright (C) 2010, Francisco Claude, all rights reserved.
 *
 * Program to test "extract" in the int-based SSA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include <ssa_words.h>
#include <iostream>
#include <fstream>
#include <sstream>

using namespace std;

int main(int argc, char ** argv) {
  if(argc!=3) {
    cout << "usage: " << argv[0] << " <index file 1> <index file 2>" << endl;
    return 0;
  }

  bool err;
  FILE * fp = fopen(argv[1],"r");
  ssa_words * ssa1 = new ssa_words(fp,err);
  fclose(fp);
  cout << "SSA1" << endl;
  ssa1->print_stats();

  fp = fopen(argv[2],"r");
  ssa_words * ssa2 = new ssa_words(fp,err);
  fclose(fp);
  cout << "SSA2" << endl;
  ssa2->print_stats();

  for(uint i=ssa1->length()-1;i>0;i--) {
    uint * s1 = ssa1->extract(i,i);
    uint * s2 = ssa2->extract(i,i);
    if(s1[0]!=s2[0]) 
      cout << "The sequences differ" << "\t ssa1["<<i<<"]="<<s1[0] << " and ssa2[" << i <<"]=" << s2[0] << endl;
    delete [] s1;
    delete [] s2;
  }


  delete ssa1;
  delete ssa2;

  return 0;
}
